

PrintWriter output;  

PImage photo; 


void setup()  
{  
  smooth();  
  //photo = loadImage("darth.jpg"); 
  // photo = loadImage("reaper.png"); 
//photo = loadImage("white.png"); 
  photo = loadImage("scarlett-johansson-1-1_thresh.png"); 
  
  
  
  
  //
  size((int)(photo.width), (int)(photo.height));  

  output = createWriter("output.g"); 

  // background(photo);
  background(255);


  output.println("G21");// we want to be in MM
  output.println("G90");// we want to be in MM
  output.println("G0");// we want to be in MM



  //set home
  //set z-5
  output.println("Z+2");
  //draw square to mark area


  drawLines(photo, 3); 
  save("output.png"); 
  output.flush();  
  output.close();  

}  

void draw() 
{  
  //nothing to do here
}  

float modifier = 0.25;
void drawLines(PImage photo, int spacing) 
{
  int lastI=0;
  int lastJ=0;
  
  int largetstJ=0;
  int largetstI=0;
  
  
  boolean isDown=false;

  for(int j = 0; j < photo.height; j+=spacing*2)  
  {
    for(int i = 0; i < photo.width-1; i+=spacing) 
    {
      PImage segment = photo.get(i, j, spacing, spacing); 
      float brighnezz = getAreaBrightness(segment); 
      float cSize =( (255-brighnezz)/45.2); 
      if(largetstJ<j)
      largetstJ=j;
    if(largetstI<i)
      largetstI=i;

      if(cSize > 1.0) 
      {
        fill(0); 
        stroke(127); 

        if(isDown==false)
        {

          output.println("G0Y"+j*modifier+"X"+i*modifier);
          lastI=i;
          lastJ=j;
          isDown=true;
          output.println("Z-0.5");

        }
      }
      else
      {
        if(isDown==true)

        {

          line(lastI,lastJ,i,j);
          output.println("G0Y"+(j*modifier)+"X"+(i*modifier));

    //      println("lastI:" + lastI + " lastJ:" + lastJ +" i:" +i +" j:"+j);
          isDown=false;
          output.println("Z+4");



        }
      }


      /*     output.println("G0Y"+j/4.5+"X"+i/4.5);
       
       
       output.println("Z-4");
       output.println("Z+4");
       
       
       
       // ellipse(i, j,4.0, 4.0);
       
       }*/
    }

    
    if(isDown==true)

    {
      output.println("G0Y"+(j*modifier)+"X"+(width*modifier));
      output.println("Z+4");
println("found end");
      //   line(lastJ,lastI,j,i);
      line(lastI,lastJ,width,j);
      //  println("lastI:" + lastI + " lastJ:" + lastJ +" i:" +i +" j:"+j);
      isDown=false;
    }
  }

println("largest j:"+largetstJ*modifier);
println("largest i:"+largetstI*modifier);



}   

float getAreaBrightness(PImage area)
{
  int bval = 0, count = 1;

  for(int i = 0; i < area.width; i++)
  {
    for(int j = 0; j < area.height; j++)
    {
      color check = area.get(i, j); 

      bval += brightness(check); //thank you processign for having all the dedious task's as functions!
      count++;
    }
  }
  return (bval/count);
}












